if(typeof Tips == "undefined")
	function Tips(){};

	
var SqueezeBox = new function(){
	
	var g_options = {};
	
	this.onClose = null;
	
	this.initialize = function(){};
	this.assign = function(){};
	
	
	/**
	 * set options
	 */
	this.setOptions = function(objOptions){
		g_options = objOptions;
	};
	
	
	/**
	 * open fancybox, set onclose function
	 */
	this.open = function(isMultiple, onCloseFunction, path, filetype){
		
		if(!filetype)
			var filetype = "image";
		
		this.onClose = onCloseFunction;
		
		var objFancybox = jQuery("#uc_fancybox_trigger");
		if(objFancybox.length == 0)
			throw new Error("fancybox trigger not found");
		
		//set url
		var urlJoomla = objFancybox.data("urljoomla");
		var urlElfinder = objFancybox.data("urlmediaselect");
		
		var openElfinder = false;
		if(isMultiple == true)
			openElfinder = true;
		
		//pass path
		if(path){
			openElfinder = true;
			urlElfinder += "&path=" + path;
		}
				
		//pass filetype
		switch(filetype){
			case "article":
				urlJoomla = objFancybox.data("urlarticle");			
			break;
			case "k2":
				urlJoomla = objFancybox.data("urlk2");
			break;
			case "image":
				var selectorType = null;
				if(g_ucAdmin)
					var selectorType = g_ucAdmin.getVal(g_options, "mediaSelectorType");
				
				if(selectorType == "elfinder")
					openElfinder = true;
			break;
			case "mp3":
				openElfinder = true;
				urlElfinder += "&filetype=mp3";
			break;
			case "module":
				urlJoomla = objFancybox.data("urlmodule");
			break;
			default:
				throw new Error("Wrong filetype: "+filetype);
			break;
		}
		
		if(openElfinder == false)
			objFancybox.attr("href", urlJoomla);
		else
			objFancybox.attr("href", urlElfinder);
		
		objFancybox.trigger("click");
	};
	
	
	
	/**
	 * close fancybox
	 */
	this.close = function(){
		jQuery(".fancybox-close").trigger("click");
	};
	
};


/**
 * 
 * on inset image, taken from iframe
 */
function jInsertFieldValue(urlImage){
	
	if(typeof SqueezeBox.onClose == "function")
		SqueezeBox.onClose(urlImage);
	
	SqueezeBox.close();
}

/**
 * select item for k2
 */
function jSelectItem(itemid, itemTitle){
	
	if(typeof SqueezeBox.onClose == "function")
		SqueezeBox.onClose({"id":itemid,"title":itemTitle});
	
	SqueezeBox.close();
}


/**
 * on choose article
 */
function uniteCreatorOnChooseArticle(articleID, articleTitle, catID){
		
	if(typeof SqueezeBox.onClose == "function")
		SqueezeBox.onClose({"id":articleID,"title":articleTitle,"catid":catID});
	
	SqueezeBox.close();
}


//global variables
var g_dataProviderUC = {
		pathSelectImages: null,
		pathSelectImagesBase:null,
		urlSelectImagesBase:null,
		objBrowserImages: null
};


/**
 * provider admin class
 */
function UniteProviderAdminUC(){
	
	var g_parent;
	var t = this;
	
	
	var g_temp = {
			keyUrlAssets: "[url_assets]/",
			mediaSelectorType: null
	};
	
	
	/**
	 * open url dialog - add image or mp3 dialog
	 */
	function openUrlDialog(title, onInsert, isMultiple, source, filetype){
		
		if(!isMultiple)
			var isMultiple = false;
		
		var pathSelect = null;
		if(source === "addon")
			pathSelect = g_dataProviderUC.pathSelectImages;
		
		SqueezeBox.open(isMultiple, function(urlImage){
						
			if(source == "addon"){
				
				jQuery.each(urlImage, function(key, item){
					
					var urlFull = item.url;
					var urlRelative = urlFull.replace(g_dataProviderUC.urlSelectImagesBase, "");
					var urlAssetsRelative = g_temp.keyUrlAssets+urlRelative;
					
					item.full_url = urlFull;
					item.url_assets_relative = urlAssetsRelative;
					
					urlImage[key] = item;
				});
				
				if(isMultiple == false)
					urlImage = urlImage[0];
				
				onInsert(urlImage);
				
			}else{
				if(isMultiple == false && jQuery.isArray(urlImage)){
					urlImage = urlImage[0].url;
					
					if(!g_parent)
						g_parent = g_ucAdmin;
					
					urlImage = g_parent.urlToRelative(urlImage);
				}
								
				onInsert(urlImage);
			}
		
		},pathSelect,filetype);
		
	}
	
	
	/**
	 * open "add image" dialog
	 */
	this.openAddImageDialog = function(title, onInsert, isMultiple, source){
		
		openUrlDialog(title, onInsert, isMultiple, source, "image");
		
	};
	
	
	/**
	 * open "add mp3" dialog
	 */
	this.openAddMp3Dialog = function(title, onInsert, isMultiple, source){

		openUrlDialog(title, onInsert, isMultiple, source, "mp3");
		
	};
	
	/**
	 * open article dialog
	 * articleType: 
	 */
	this.openSelectArticleDialog = function(title, onInsert, articleType){
		
		if(!articleType)
			var articleType = "article";
				
		openUrlDialog(title, onInsert, false, null, articleType);
	};
	
	/**
	 * open article dialog
	 * articleType: 
	 */
	this.openSelectModuleDialog = function(title, onInsert, moduleType){
		
		if(!moduleType)
			var moduleType = "module";
		
		openUrlDialog(title, onInsert, false, null, moduleType);
	};
	
	/**
	 * get shortcode
	 */
	this.getShortcode = function(alias, catid){
		
		var addhtml = "";
		if(catid)
			addhtml = " catid="+catid;
		
		var shortcode = "{unitecreator "+alias + addhtml + "}";
		
		if(alias == "")
			shortcode = "";
		
		return(shortcode);
	};
	
	
	/**
	 * run on update settings events
	 */
	this.onSettingsUpdateEvents = function(objParent){
		
		//remove chosen elements
		setTimeout(function(){
			
			var objSelects = objParent.find(".chzn-done");
			objSelects.each(function(index, select){
				var objSelect = jQuery(select);
				var selectID = objSelect.prop("id");
				var idChosen = selectID + "_chzn";
				jQuery("#"+idChosen).remove();
				objSelect.show().removeClass(".chzn-done");
			});
			
		}, 500);

	};

	
	/**
	 * convert url assets related to full url
	 */
	this.urlAssetsToFull = function(url){
				
		if(!url)
			return("");
		
		if(!g_dataProviderUC.urlSelectImagesBase)
			return(url);
		
		var key = g_temp.keyUrlAssets;
		
		if(url.indexOf(key) == -1)
			return(url);
		
		url = url.replace(key, g_dataProviderUC.urlSelectImagesBase);
				
		return(url);
		
	};
	
	
	/**
	 * set select images path
	 */
	this.setPathSelectImages = function(path, basePath, baseUrl){
		
		if(basePath != null)
			g_dataProviderUC.pathSelectImagesBase = basePath;
		
		g_dataProviderUC.urlSelectImagesBase = baseUrl;
		g_dataProviderUC.pathSelectImages = path;
		
	};
	
	
	/**
	 * init the provider admin object
	 */
	this.init = function(){
		
		window.g_activeEditorID = null;
		
		//replace the function
		window.jInsertEditorText = function(text, editorID){
			if(!editorID)
				var editorID = window.g_activeEditorID;
						
			appendToEditor(editorID, text);
			
			SqueezeBox.close();
		};
		
		//init debug
		//jQuery("#div_debug").draggable();
		
		//init fancybox trigger
		if(typeof jQuery("#uc_fancybox_trigger").fancybox == "function"){
			
			jQuery("#uc_fancybox_trigger").fancybox({
				'width'				: 1000,
				'height'			: 600,
				'autoScale'			: false,
				'transitionIn'		: 'none',
				'transitionOut'		: 'none',
				'type'				: 'iframe'
			});
			
		}
			
		
		//init general settings
		var objSettings = jQuery.parseJSON(g_ucGeneralSettings);
		g_temp.mediaSelectorType = g_parent.getVal(objSettings, "joomla_media_selector");
		
		SqueezeBox.setOptions(g_temp);
	};
	
	
	/**
	 * set parent
	 */
	this.setParent = function(parent){
		g_parent = parent;
	}
	
	
	/**
	 * get first editor options
	 */
	function initEditor_tinyMCE_GetOptions(){
				
		var objEditorsOptions = tinyMCE.editors;
		
		if(objEditorsOptions.length == 0)
			throw new Error("no active editors found for options gethering");
		
		for(key in objEditorsOptions){
			var editor = objEditorsOptions[key];
			if(editor && editor.settings)
				return(editor.settings);
		}
		
		throw new Error("editors options not found");
	}
	
	
	/**
	 * insert value to editor
	 */
	function appendToEditor(editorID, value){
		
		var objEditor = tinyMCE.EditorManager.get(editorID);
		if(objEditor)
			objEditor.execCommand("mceInsertContent", false, value);
		
	}
	
	
	/**
	 * init editor buttons
	 */
	function initEditors_buttons(inputID){
		
		//trace(inputID);
		var objButtonsWrapper = jQuery("#"+inputID+"_row #editor-xtd-buttons");
		if(objButtonsWrapper.length == 0)
			return(false);
		
		var objButtons = objButtonsWrapper.children("a");
		
		objButtons.off("click");
		
		//onclick event
		objButtons.click(function(){
						
			var objButton = jQuery(this);
			
			var className = objButton.find("i").attr("class");
			
			switch(className){
				case "icon-file-add":
					
					addArticleFromDialogToEditor(inputID)
										
				break;
				case "icon-picture":
					
					addImageFromDialogToEditor(inputID)
										
				break;
			}					
			
		});
		
	}
	
	/**
	 * get content of some editor by id
	 */
	this.editorTinyMCEGetContent = function(inputID){
		
		var objInput = jQuery("#"+inputID);
		if(objInput.length == 0)
			throw new Error("editor with id: "+inputID+" not found");
		
		var objEditor = tinyMCE.EditorManager.get(inputID);
		if(objEditor){
			return objEditor.getContent();
		}else{
			return objInput.val();
		}		
	};
	
	/**
	 * set content to the editor
	 */
	this.editTinyMCESetContent = function(inputID, value){
		
		var objInput = jQuery("#"+inputID);
		if(objInput.length == 0)
			return(false);
			
		var objEditor = tinyMCE.EditorManager.get(inputID);
				
		if(objEditor){
			objEditor.setContent(value);
		}else{
			objInput.val(value);
		}
		
	};
	
	
	/**
	 * focus editor
	 */
	function focusTinyMceEditor(inputID){
		
		tinymce.execCommand('mceFocus', false, inputID);
	}
	
	
	/**
	 * hide float panels
	 */
	function tinyMCEHideFloatPanels(){
		
		jQuery(".mce-floatpanel").hide();
	}
	
	
	/**
	 * open inline full editor
	 */
	function openInlineFullEditor(editor){
		
		var objElement = editor.getElement();
		objElement = jQuery(objElement);
		
		var inputID = objElement.prop("id");
		var dialogID = inputID+"_dialog";
		
		var objDialog = jQuery("#"+dialogID);
		
		g_ucAdmin.validateDomElement(objDialog, "items dialog");
		
		var buttonOpts = {};
		
		buttonOpts[g_uctext.update] = function(){
			
			var objTextarea = objDialog.find("textarea");
			var inputID = objTextarea.prop("id");
			
			var content = t.editorTinyMCEGetContent(inputID);
			editor.setContent(content);
			editor.fire("keyup");
						
			objDialog.dialog("close");			
		};
		
		var dialogOptions = {
				buttons:buttonOpts,
				minWidth:1000,
				height:400,
				modal:true,
				dialogClass:"unite-ui",
				open:function(){
					var objTextarea = objDialog.find("textarea");
					g_ucAdmin.validateDomElement(objTextarea, "text area");
					
					var content = editor.getContent();
					
					var inputID = objTextarea.prop("id");
					
					t.editTinyMCESetContent(inputID, content);
					
					initEditor_tinyMCE(inputID);
					
					tinyMCEHideFloatPanels();	//close inline float panels
					
					setTimeout(function(){
						
						focusTinyMceEditor(inputID);
					}, 500);
				}
			};
		
		objDialog.dialog(dialogOptions);
		
	}
	
	/**
	 * trigger change on editor, pass back
	 */
	function onEditorChange(editor, objSettings){
		
		var objInput = editor.getElement();
		objInput = jQuery(objInput);
		objSettings.triggerKeyupEvent(objInput);
	}	
	
	
	/**
	 * turn options to inline options for tinymce editor
	 */
	function getTinyMCEOptionsInline(options, objSettings){
		
		options.inline = true;
		
		var toolbar1 = "";
		toolbar1 += "bold italic";
		toolbar1 += " | alignleft aligncenter alignright";
		toolbar1 += " | forecolor | code";
		toolbar1 += " | openfull";
		
		options.toolbar1 = toolbar1;
		//options.toolbar2 = "formatselect fontselect fontsizeselect";
		
		/*
		options.menu = {
			    insert: {title: 'Insert', items: 'media image link | anchor hr| charmap emoticons'},
			    edit: {title: 'Edit', items: 'undo redo | cut copy paste pastetext | selectall'},
			    format: {title: 'Format', items: 'bold italic underline strikethrough superscript subscript | formats | fontselect | removeformat'}
		 };
		*/
		
		options.menubar = "edit insert format";
		
		options.setup = function(editor){
			
			editor.on('Change', function(event) {
				onEditorChange(editor, objSettings);
			});			
			
			editor.on('keyup', function(event) {
				onEditorChange(editor, objSettings);
			});			
			
			editor.addButton('openfull', {
			      icon: 'fullscreen',
			      tooltip: "Edit in Full Editor",
			      onclick: function(){
			    	  openInlineFullEditor(editor);
			      }
			});
			
		};
		
		return(options);
	}
	
	/**
	 * add image from dialog to editor
	 */
	function addImageFromDialogToEditor(inputID){
		t.openAddImageDialog("Select Image",function(urlImage){
  		  var html = '<img src="' + urlImage +'"/>';				    		  
	    	  appendToEditor(inputID, html);
  	  });
		
	}
	
	
	/**
	 * add article from dialog to editor
	 */
	function addArticleFromDialogToEditor(inputID){
		
		t.openSelectArticleDialog("Choose Article", function(objArticle){
			var link = "index.php?option=com_content&amp;view=article&amp;id="+objArticle.id;
			if(objArticle.catid)
				link += "&amp;catid="+objArticle.catid;
			
			var html = "<a href=\""+link+"\">"+objArticle.title+"</a>";
			appendToEditor(inputID, html);
		});
		
	}

	/**
	 * add article from dialog to editor
	 */
	function addModuleFromDialogToEditor(inputID){
		
		window.g_activeEditorID = inputID;
		
		t.openSelectModuleDialog("Choose Module", function(objModule){
		});
		
	}
	
	/**
	 * setup inline buttons
	 */
	function initEditor_tinyMCE_setupInlineButtons(options, inputID){
		
		var toolbar = options.toolbar1;
		var arrButtons = toolbar.split(" ");
				
		var objButtonKeys = {};
		
		var keyButtonArticle = null;
		var keyButtonImage = null;
		var keyButtonModule = null;
		
		for(var index in arrButtons){
			var button = arrButtons[index];
			if(button.indexOf("button-") !== 0)
				continue;
			
			//replace image
			if(button.indexOf("Image") != -1)
				keyButtonImage = button;
			
			if(button.indexOf("Article") != -1)
				keyButtonArticle = button;
			
			if(button.indexOf("Module") != -1)
				keyButtonModule = button;
			
			//remove buttons
			if(button.indexOf("Menu") != -1)
				options.toolbar1 = options.toolbar1.replace(button,"");
			
			if(button.indexOf("Contact") != -1)
				options.toolbar1 = options.toolbar1.replace(button,"");
			
		}
				
		//add custom functions to setup
		var funcSetup = null;
		if(typeof options.setup == "function")
			funcSetup = options.setup;
				
		options.setup = function(editor){
			
			if(funcSetup)
				funcSetup(editor);
			
			//override image
			if(keyButtonImage){
				var objButton = editor.buttons[keyButtonImage];
				editor.addButton(keyButtonImage,{
					
					  text: objButton.text,
					  title: objButton.title,
				      icon: objButton.icon,
				      onclick: function(){
				    		 addImageFromDialogToEditor(inputID);
				      }
				});
			}
			
			//override article
			if(keyButtonArticle){
				var objButton = editor.buttons[keyButtonArticle];
				editor.addButton(keyButtonArticle,{
					
					  text: objButton.text,
					  title: objButton.title,
				      icon: objButton.icon,
				      onclick: function(){
				    		 addArticleFromDialogToEditor(inputID);				    	  				    	  
				      }
					
				});
			}
			
			//override module
			if(keyButtonModule){
				var objButton = editor.buttons[keyButtonModule];
				editor.addButton(keyButtonModule,{
					
					  text: objButton.text,
					  title: objButton.title,
				      icon: objButton.icon,
				      onclick: function(){
				    		 addModuleFromDialogToEditor(inputID);				    	  				    	  
				      }
					
				});
			}
			
			
						
		};
		
		
		return(options);
	}
	
	/**
	 * init tinymce editor
	 * take options from existing editor on page
	 */
	function initEditor_tinyMCE(inputID, isInline, objSettings){
		
		if(isTinyMCEEditorExists(inputID) == true)
			return(false);
		
		var options = initEditor_tinyMCE_GetOptions();
		
		var moreOptions = {
			directionality: "ltr",
            resize: "vertical",
            height: 200,
            id: inputID,
            selector: "#"+inputID
		};
		
		jQuery.extend(options, moreOptions);
		
		//avlid duplicated
		var finalOptions = jQuery.extend({},options);
		
		if(isInline == true)
			finalOptions = getTinyMCEOptionsInline(finalOptions, objSettings);
		else
			finalOptions = initEditor_tinyMCE_setupInlineButtons(finalOptions, inputID);
		
		//trace(finalOptions);
		
		tinyMCE.init(finalOptions);
		
		initEditors_buttons(inputID);
		
	}
	
	
	/**
	 * check if editor exists
	 */
	function isTinyMCEEditorExists(inputID){
		
		if(tinyMCE.editors.hasOwnProperty(inputID) == false || tinyMCE.editors[inputID] === null)
			return(false);
		
		return(true);
	}
	
	
	/**
	 * get array of inited editors
	 */
	function initEditors_afterTimeout(objSettings, arrEditorNames){
		
		var idPrefix = objSettings.getIDPrefix();
		idPrefix = idPrefix.replace("#","");
		
		jQuery(arrEditorNames).each(function(index, name){
			var inputID = idPrefix + name;
			
			var isInline = false;
			var objInput = jQuery("#"+inputID);
			if(objInput.hasClass("unite-setting-inline-editor"))
				isInline = true;
			
			initEditor_tinyMCE(inputID, isInline, objSettings);
			
		});
		
	}
	
	
	/**
	 * run timymce protection
	 * the blame is: focusTabbable in jquery ui
	 */
	function runTinyMCEProtections(){
		
		var isProtected = jQuery(document).data("unite_tinymce_protected");
		if(isProtected === true)
			return(false);
		
		jQuery(document).data("unite_tinymce_protected", true);
		
		
		// Prevent jQuery UI dialog from blocking focusin
		jQuery(document).on('focusin', function(e) {
				
		   if (jQuery(e.target).closest(".mce-window, .moxman-window").length) {
			 e.stopImmediatePropagation();
		   }
		});
		
	}
	
	
	/**
	 * destroy tinymce editor
	 */
	function destroyTinyMceEditor(editorID){
		
		var objEditor = tinyMCE.EditorManager.get(editorID);
		if(objEditor){
			try{
				
				if(tinymce.majorVersion === "4")
					window.tinyMCE.execCommand("mceRemoveEditor", !0, editorID);
				else		
					window.tinyMCE.execCommand("mceRemoveControl", !0, editorID);
				
			}catch(e){					
			}
		}
	}
	
	
	/**
	 * destroy editors
	 */
	this.destroyEditors = function(objSettings){
		
		var arrEditorNames = objSettings.getFieldNamesByType("editor_tinymce");
		if(arrEditorNames.length == 0)
			return(false);
		
		var idPrefix = objSettings.getIDPrefix();
		idPrefix = idPrefix.replace("#","");
		
		jQuery.each(arrEditorNames, function(index, name){
			var editorID = idPrefix+name;
			editorID = editorID.replace("#","");
			destroyTinyMceEditor(editorID);
			
			editorFullID = editorID+"_full";
			destroyTinyMceEditor(editorFullID);
			
		});
		
	};
	
	
	/**
	 * init editors
	 */
	this.initEditors = function(objSettings){
		
		var arrEditorNames = objSettings.getFieldNamesByType("editor_tinymce");
		if(arrEditorNames.length == 0)
			return(false);
		
		if(typeof tinyMCE == "undefined")
			throw new Error("Init editors error: no editor js loaded");
				
		//runTinyMCEProtections();
		
		if(tinyMCE.editors.length){
			initEditors_afterTimeout(objSettings, arrEditorNames);			
		}else{
			
			//wait until init
			
			var counter = 0;
			var handle = setInterval(function(){
				
				if(tinyMCE.editors.length){
					clearInterval(handle);
					initEditors_afterTimeout(objSettings, arrEditorNames);			
				}
				
				counter++;
				if(counter >= 100){
					clearInterval(handle);
					throw new Error("Init editor error - no other inited editors found");
				}
				
			},50);
			
		}
		
	}
	
	
}