<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');


   class UniteProviderAdminUC extends UniteCreatorAdmin{
   	
   		
		/**
		 *
		 * the constructor
		 */
		public function __construct(){
			parent::__construct();
			
			$this->init();
		}		
		
		/**
		 *
		 * admin pages
		 */
		public function adminPages(){
			
			parent::adminPages();
			
			//set default title
			HelperProviderUC::setToolbarTitle();
		}
		
		
		/**
		 * validate view if called single way
		 */
		public static function validateSingleView($view){
			
		}
		
		/**
		 * add filter
		 */
		protected function addFilter($tag, $function_to_add, $priority = 10, $accepted_args = 1){
			UniteProviderFunctionsUC::addFilter($tag, array($this,$function_to_add), $priority, $accepted_args);
		}
		
		/**
		* add action
		 */
		protected function addAction($tag, $function_to_add, $priority = 10, $accepted_args = 1){
			
			UniteProviderFunctionsUC::addAction($tag, array($this,$function_to_add), $priority, $accepted_args);
		}
		
		/**
		 * get general settings
		 */
		public function getClientsideGeneralSettings($arrSettings){
			
			$arrSettings["joomla_media_selector"] = HelperUC::getGeneralSetting("joomla_media_selector");
			
			return($arrSettings);
		}
		
		/**
		 * get admin page body
		 */
		private function getAdminPageBody(){
			
			ob_start();
				
			$this->adminPages();
			
			$content = ob_get_contents();
			ob_end_clean();
			
			return($content);
		}
		
		
		/**
		 * get script option html
		 */
		private function getHtmlScriptOptions(){
			
			$document = JFactory::getDocument();
			
			if(method_exists($document, "getScriptOptions") == false)
				return(false);
			
			$scriptOptions = $document->getScriptOptions();
			
			if(empty($scriptOptions))
				return("");
			
			$html = "";
			$html .= '	<script type="application/json" class="joomla-script-options new">';

			$prettyPrint = (JDEBUG && defined('JSON_PRETTY_PRINT') ? JSON_PRETTY_PRINT : false);
			$jsonOptions = json_encode($scriptOptions, $prettyPrint);
			$jsonOptions = $jsonOptions ? $jsonOptions : '{}';

			$html .= $jsonOptions;
			$html .= '</script>'."\n";
			
			return($html);
		}
		
		
		/**
		 * load in blank window html
		 */
		private function loadBlankWindowAdminPage(){
			
			$htmlBody = $this->getAdminPageBody();
			
			UniteFunctionJoomlaUC::disableJoomlaPreviewFiles();
			
			//get title
			$document = JFactory::getDocument();
			$title = $document->title;
			$title = htmlspecialchars($title);
				
			HelperUC::addStyle("blank_page_preview","uc_blank_page_preview");
			
			$cssStyles = UniteProviderFunctionsUC::getCustomStyles();
			$arrScripts = UniteProviderFunctionsUC::getCustomScripts();
			
			$htmlScriptOptions = $this->getHtmlScriptOptions();
			
			$htmlJSScripts = HelperHtmlUC::getHtmlCustomScripts($arrScripts);
			
			$arrIncludes = UniteProviderFunctionsUC::getArrScriptsAndStyleIncludes(true);
			$arrIncludesCss = $arrIncludes["styles"];
			$arrIncludesJs = $arrIncludes["scripts"];
			
			$htmlIncludesCss = HelperHtmlUC::getHtmlCssIncludes($arrIncludesCss, HtmlOutputBaseUC::TAB2);
			$htmlIncludesJs = HelperHtmlUC::getHtmlJsIncludes($arrIncludesJs, HtmlOutputBaseUC::TAB2);
						
			$view = self::$view;
			$urlFavicon = GlobalsUC::$urlPlugin."images/favicon.png";
			
			?>
<!DOCTYPE html>
<html>
<head>
	<title><?php echo $title?></title>
	<link rel="shortcut icon" href="<?php echo $urlFavicon?>">
	
	<?php if(!empty($cssStyles)):?>
	<style type='text/css'>
		<?php echo $cssStyles?>
	</style>
	<?php endif?>
	
	<?php echo $htmlIncludesCss?>
	<?php echo $htmlScriptOptions?>
	<?php echo $htmlIncludesJs?>
	
	<?php echo $htmlJSScripts?>
	
</head>
<body class="uc-blank-preview uc-view-<?php echo $view?>">
	<?php echo $htmlBody?>
</body>
</html>

		<?php
		
		exit();
		}
		
		/**
		 * add scripts
		 */
		public static function onAddScripts(){
			
			parent::onAddScripts();

			$viewForIncludes = self::$view;
			
			//take from view aliased if exists
			if(isset(GlobalsUC::$arrViewAliases[$viewForIncludes]))
				$viewForIncludes = GlobalsUC::$arrViewAliases[$viewForIncludes];
			
			switch ($viewForIncludes){
				case "media":
					$urlElfinder = GlobalsUC::$url_provider."elfinder/";
					
					HelperUC::addStyleAbsoluteUrl($urlElfinder."jquery/ui-themes/smoothness/jquery-ui-1.10.1.custom.css", "elfinder-jquery-ui-css");
					HelperUC::addStyleAbsoluteUrl($urlElfinder."css/elfinder_full.css", "elfinder-css");
					
					
					HelperUC::addScriptAbsoluteUrl($urlElfinder."jquery/jquery-ui-1.10.1.custom.min.js", "jquery-ui");
					HelperUC::addScriptAbsoluteUrl($urlElfinder."js/elFinder.js", "elfinder-js");
					HelperUC::addScriptAbsoluteUrl($urlElfinder."jsmin/elfinder.min2.js", "elfinder-js-min2");
					HelperUC::addScriptAbsoluteUrl($urlElfinder."js/jquery.elfinder.js", "jquery-elfinder");
					HelperUC::addScriptAbsoluteUrl($urlElfinder."jsmin/elfinder.min.js", "elfind-js-min");
					HelperUC::addScriptAbsoluteUrl($urlElfinder."js/i18n/elfinder.en.js", "elfind-english");
					HelperUC::addScriptAbsoluteUrl($urlElfinder."js/jquery.dialogelfinder.js", "elfinder-dialogfinder");
					HelperUC::addScriptAbsoluteUrl($urlElfinder."js/proxy/elFinderSupportVer1.js", "elfinder-proxy");
					
				break;
			}
			
			
		}
		
		
		/**
		 *
		 * init function
		 */
		public function init(){
			
			parent::init();
			
			
			//addon_library_preview_output_before_process_includes
			
			$this->addFilter(UniteCreatorFilters::FILTER_CLIENTSIDE_GENERAL_SETTINGS, "getClientsideGeneralSettings");
			
			//check if there is ajax action. If not, exit to admin pages
			self::onAjaxAction();
			
			self::onAddScripts();
			
			if(GlobalsUC::$blankWindowMode == true && UniteProviderFunctionsUC::$isStandAlone == false){
				$this->loadBlankWindowAdminPage();
			}
			else	
				$this->adminPages();
			
		}
		
		
	}

?>