<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');


define("BLOXBUILDER_TEXTDOMAIN","unitecreator");

class UniteProviderFunctionsUC{
	
	public static $tablePrefix;
	public static $objOptions;
	public static $isStandAlone = false;
	
	
	/**
	 * init base variables of the globals
	 */
	public static function initGlobalsBase(){
		
		if(!defined("JPATH_ROOT") || defined("BLOX_STAND_ALONE")){
			self::initGlobalsStandAlone();
			return(false);
		}
		
		$tablePrefix = "#__";
		
		self::$tablePrefix = $tablePrefix;
		
		GlobalsUC::$table_addons = $tablePrefix.GlobalsUC::TABLE_ADDONS_NAME;
		GlobalsUC::$table_categories = $tablePrefix.GlobalsUC::TABLE_CATEGORIES_NAME;
		GlobalsUC::$table_layouts = $tablePrefix.GlobalsUC::TABLE_LAYOUTS_NAME;
		
		$pluginName = "com_blox";
				
		GlobalsUC::$url_base = JURI::root();
		
		$pathMedia = JPATH_ROOT."/media/".$pluginName."/";
		
		$urlMedia = GlobalsUC::$url_base."media/{$pluginName}/";
		
		GlobalsUC::$pathPlugin = realpath(JPATH_ADMINISTRATOR."/components/".$pluginName)."/";
		
		GlobalsUC::$path_base = JPATH_ROOT."/";
		
		$paramsMedia = JComponentHelper::getParams('com_media');
		$dirUploads =  $paramsMedia->get("file_path");
		if(empty($dirUploads))
			$dirUploads = $paramsMedia->get("image_path");
		if(empty($dirUploads))
			$dirUploads = "images";
		
		
		GlobalsUC::$path_images = GlobalsUC::$path_base.$dirUploads."/";
		
		GlobalsUC::$urlPlugin = GlobalsUC::$url_base."administrator/components/{$pluginName}/";
		
		GlobalsUC::$url_component_client = GlobalsUC::$url_base."index.php?option=".$pluginName;
		GlobalsUC::$url_component_admin = GlobalsUC::$url_base."administrator/index.php"."?option=".$pluginName;
		
		GlobalsUC::$url_images = GlobalsUC::$url_base."images/";
				
		GlobalsUC::$is_ssl = UniteFunctionJoomlaUC::isSSL();
		
		GlobalsUC::$path_cache = $pathMedia."cache/";
		
		self::initGlobalSecondaryVars($pathMedia, $urlMedia);
	}
	
	
	/**
	 * init vars secondary
	 */
	private static function initGlobalSecondaryVars($pathMedia, $urlMedia){
		
		GlobalsUC::$pathLibrary = $pathMedia."assets_libraries/";
				
		GlobalsUC::$url_component_admin_nowindow = UniteFunctionsUC::addUrlParams(GlobalsUC::$url_component_admin, "ucwindow=blank");
		
		GlobalsUC::$url_ajax = GlobalsUC::$url_component_admin;
		GlobalsUC::$url_ajax_front = GlobalsUC::$url_component_client;
		
		GlobalsUC::$is_admin = self::isAdmin();
		
		GlobalsUC::$pathAssets = $pathMedia."assets/";
		GlobalsUC::$url_assets = $urlMedia."assets/";
		GlobalsUC::$url_assets_internal = $urlMedia."assets_internal/";
		
		GlobalsUC::$url_provider = GlobalsUC::$urlPlugin."provider/";
		GlobalsUC::$url_default_addon_icon = GlobalsUC::$url_provider."assets/images/icon_default_addon.png";
		
		GlobalsUC::$url_assets_libraries = $urlMedia."assets_libraries/";
		
		GlobalsUC::$view_default = GlobalsUC::VIEW_LAYOUTS_LIST;
		
		$joomlaTemplate = UniteFunctionsUC::getGetVar("tmpl","", UniteFunctionsUC::SANITIZE_KEY);
		if($joomlaTemplate == "component")
			GlobalsUC::$blankWindowMode = true;
		
		$window = UniteFunctionsUC::getGetVar("ucwindow", "",UniteFunctionsUC::SANITIZE_KEY);
		if($window == "blank")
			GlobalsUC::$blankWindowMode = true;
		
	}
	
	
	/**
	 * init globals stand alone
	 */
	public static function initGlobalsStandAlone(){
		
		self::$isStandAlone = true;
		
		self::$tablePrefix = GlobalsStandAlone::$tablePrefix;
		
		GlobalsUC::$table_addons = self::$tablePrefix.GlobalsUC::TABLE_ADDONS_NAME;
		GlobalsUC::$table_categories = self::$tablePrefix.GlobalsUC::TABLE_CATEGORIES_NAME;
		GlobalsUC::$table_layouts = self::$tablePrefix.GlobalsUC::TABLE_LAYOUTS_NAME;
		
		$dirPlugin = "blox-plugin";
		
		GlobalsUC::$url_base = GlobalsStandAlone::$urlBase;
		GlobalsUC::$path_base = GlobalsStandAlone::$pathBase;
		
		$pathPluginGlobal = GlobalsStandAlone::$pathBase.$dirPlugin."/";
		
		GlobalsUC::$pathPlugin = $pathPluginGlobal."admin/";
		
		$pathUploads = GlobalsUC::$path_base."uploads/";
		$pathMedia = $pathPluginGlobal."media/";
		
		GlobalsUC::$path_images = $pathUploads."images/";
		
		$urlPluginBase = GlobalsUC::$url_base.$dirPlugin."/";
		
		GlobalsUC::$urlPlugin = GlobalsUC::$url_base.$dirPlugin."/admin/";
		
		$urlMedia = $urlPluginBase."media/";
		
		$urlUploads = GlobalsUC::$url_base."uploads/";
				
		GlobalsUC::$url_component_client = GlobalsUC::$url_base."index.php";
		GlobalsUC::$url_component_admin = GlobalsUC::$url_base."admin/index.php";
		
		GlobalsUC::$url_images = $urlUploads."images/";
		
		GlobalsUC::$is_ssl = HelperProviderUC::isSSLByPHP();
		
		GlobalsUC::$path_cache = GlobalsUC::$path_base."cache/";
		
		self::initGlobalSecondaryVars($pathMedia, $urlMedia);
				
		//validation
		
		UniteFunctionsUC::validateDir(GlobalsUC::$path_images, "images path");
		UniteFunctionsUC::validateDir(GlobalsUC::$path_cache, "cache path");
		UniteFunctionsUC::validateDir(GlobalsUC::$path_base, "base path");
		UniteFunctionsUC::validateDir($pathMedia, "media path");

		//GlobalsUC::printVars();
	}
	
	
	/**
	 * get object function
	 */
	public static function getObjOptions(){
		
		if(empty(self::$objOptions))
			self::$objOptions = new ProviderOptionsUC();
		
		return(self::$objOptions);
	}
	
	
	/**
	 * add scripts and styles framework
	 */
	public static function addScriptsFramework(){

		self::addAdminJQueryInclude();

		//include jquery ui
		$includejQueryUI = true;
		
		$view = UniteCreatorAdmin::getView();
		if($view == "media")
			$includejQueryUI = false;
					
		if($includejQueryUI == true){
			$urljQueryUI = GlobalsUC::$url_provider."assets/jquery-ui.min.js";
			HelperUC::addScriptAbsoluteUrl($urljQueryUI, "jquery-ui");
			
			HelperUC::addStyle("jquery-ui.min","jui-minified","css/jui/new");
		}
		
		$urlFancyboxJs = GlobalsUC::$url_provider."assets/fancybox/jquery.fancybox.pack.js";
		HelperUC::addScriptAbsoluteUrl($urlFancyboxJs, "fancybox");
		
		$urlFancyboxCss = GlobalsUC::$url_provider."assets/fancybox/jquery.fancybox.css";
		HelperUC::addStyleAbsoluteUrl($urlFancyboxCss, "fancybox-css");
		
	}
	
	
	/**
	 * add admin jquery include
	 */
	public static function addAdminJQueryInclude(){
		
		if(UniteProviderFunctionsUC::$isStandAlone == true)
			$isJoomla3 = false;
		else
			$isJoomla3 = UniteFunctionJoomlaUC::isJoomla3();
		
		if($isJoomla3 == false){
			$urljQuery = GlobalsUC::$url_provider."assets/jquery-1.11.1.min.js";
			HelperUC::addScriptAbsoluteUrl($urljQuery, "jquery");
						
		}
		else{
			JHtml::_('jquery.framework');
		}
		
	}
	
	
	/**
	 *
	 * register script
	 */
	public static function addScript($handle, $url){
		
		if(empty($url))
			UniteFunctionsUC::throwError("empty script url, handle: $handle");
		
		$url = UniteFunctionsUC::addUrlParams($url, "ucver=".BLOXBUILDER_VERSION);
		
		$document = JFactory::getDocument();
		
		if(UniteProviderFunctionsUC::$isStandAlone == true)
			$document->addScript($url, $handle);
		else
			$document->addScript($url);
		
	}
	
	
	/**
	 *
	 * register script
	 */
	public static function addStyle($handle, $url, $type = null){
	
		if(empty($url))
			UniteFunctionsUG::throwError("empty style url, handle: $handle");
		
		$document = JFactory::getDocument();
				
		if($type == "canonical"){
			
			$document->addHeadLink( $url, 'canonical', 'rel');
			return(false);
		}
		
		$url = UniteFunctionsUC::addUrlParams($url, "ucver=".BLOXBUILDER_VERSION, true);
						
		if(UniteProviderFunctionsUC::$isStandAlone == true)
			$document->addStyleSheet($url, $handle);
		else
			$document->addStyleSheet($url);
			
	}
	
	
	/**
	 *
	 * sanitize data, in joomla no need to sanitize
	 */
	public static function normalizeAjaxInputData($arrData){
	
		return $arrData;
	}
	
	
	/**
	 * put footer text line
	 */
	public static function putFooterTextLine(){
		?>
			&copy; <?php _e("All rights reserved",BLOXBUILDER_TEXTDOMAIN)?>, <a href="http://blox-builder.com" target="_blank">BloxThemes</a>. &nbsp;&nbsp;
		<?php
	}
		
	
	/**
	 * print custom script
	 */
	public static function printCustomScript($script, $hardCoded = false){
		
		if($hardCoded == false)
			UniteFunctionJoomlaUC::addScriptDeclaration($script);
		else
			echo "<script type='text/javascript'>{$script}</script>";
	
	}
	
	/**
	 * print custom script
	 */
	public static function printCustomStyle($style, $hardCoded = false){
		
		if($hardCoded == false)
			UniteFunctionJoomlaUC::addStyleDeclaration($style);
		else
			echo "<style type='text/css'>{$style}</style>";
	
	}
	
	/**
	 * get custom styles
	 */
	public static function getCustomStyles(){
		
		$document = JFactory::getDocument();
		
		if(UniteProviderFunctionsUC::$isStandAlone == true){
			
			$cssStyles = HelperStandAlone::getAdminCustomCss();
			
		}else{
			$arrStyles = $document->_style;
			$cssStyles = UniteFunctionsUC::getVal($arrStyles, "text/css");
		}
				
		return($cssStyles);
	}
	
	/**
	 * get custom scripts array
	 */
	public static function getCustomScripts(){
		
		$document = JFactory::getDocument();
		
		if(UniteProviderFunctionsUC::$isStandAlone == true){
			
			$jsScripts = HelperStandAlone::getAdminCustomScriptsArray();
			
		}else{
			
			$arrScripts = $document->_script;
			$jsScripts = UniteFunctionsUC::getVal($arrScripts, "text/javascript");
			
			if(is_string($jsScripts))
				$jsScripts = array($jsScripts);
		}
		
		
		return($jsScripts);
	}
	
	/**
	 * get custom tags
	 */
	public static function getCustomTags(){
		
		$document = JFactory::getDocument();
		
		$arrCustom = $document->_custom;
				
		return($arrCustom);
	}
	
	/**
	 * get array of scripts and styles includes
	 */
	public static function getArrScriptsAndStyleIncludes($forPreview = false){
		
		if($forPreview == true)
			UniteFunctionJoomlaUC::disableJoomlaPreviewFiles();
		
		$document = JFactory::getDocument();
		$arrDocuScripts = $document->_scripts;
		
		
		//get scripts
		$arrScripts = array();
		if(empty($arrDocuScripts))
			$arrDocuScripts = array();
		
		foreach($arrDocuScripts as $urlScript=>$arr){
			
			if(self::$isStandAlone == true)
				$arrScripts[] = $arr;
			else{
				if(is_numeric($urlScript) && is_string($arr))
					$arrScripts[] = $arr;
				else
					$arrScripts[] = $urlScript;
			}
		}
		
		//get styles
		$arrDocuStyles = $document->_styleSheets;
		if(empty($arrDocuStyles))
			$arrDocuStyles = array();
		
		$arrStyles = array();
		foreach($arrDocuStyles as $urlStyle=>$arr){
			if(is_string($arr))
				$arrStyles[] = $arr;
			else
				$arrStyles[] = $urlStyle;
		}
		
		//get links:
		$arrLinks = @$document->_links;
		if(empty($arrLinks))
			$arrLinks = array();
				
		$output = array();
		$output["scripts"] = $arrScripts;
		$output["styles"] = $arrStyles;
		$output["links"] = $arrLinks;
				
		return($output);
	}
	
	
	/**
	 * get if area is admin or not
	 */
	public static function isAdmin(){
		
		if(self::$isStandAlone == true)
			return(GlobalsStandAlone::$isAdmin);
		
		
		$app = JFactory::getApplication();
		return($app->isAdmin());		
	
	}
	
	
	/**
	 * put master provider html
	 */
	public static function putMasterHTML(){
		
		$urlJoomla = "index.php?option=com_media&view=images&tmpl=component&author=&fieldid=field_image_dialog_choose";
		$urlArticle = "index.php?option=com_content&view=articles&layout=modal&tmpl=component&function=uniteCreatorOnChooseArticle";
		$urlK2 = "index.php?option=com_k2&view=items&task=element&tmpl=component&object=jform[request][id]";
		$urlModule = "index.php?option=com_modules&view=modules&layout=modal&tmpl=component&task=element&object=jform[request][id]";		
		
		$urlElfinder = HelperUC::getViewUrl(GlobalsUC::VIEW_MEDIA_SELECT);
		$text = __("Fancybox Trigger", BLOXBUILDER_TEXTDOMAIN);
		
		?>
			<a id="uc_fancybox_trigger" style="display:none" data-urlk2="<?php echo $urlK2?>" data-urlarticle="<?php echo $urlArticle?>" data-urljoomla="<?php echo $urlJoomla?>" data-urlmediaselect="<?php echo $urlElfinder?>" data-urlmodule="<?php echo $urlModule?>" href="<?php echo $urlJoomla?>"><?php echo $text?></a>
		<?php 
	}

	
	/**
	 * add system contsant data to template engine
	 */
	public static function addSystemConstantData($data){
		
		$data["uc_platform_title"] = "Joomla!";
		$data["uc_platform"] = "blox_joomla";
		
		$data["uc_url_home"] = GlobalsUC::$url_base;
		$data["uc_url_blog"] = GlobalsUC::$url_base;
		
		return($data);
	}

	/**
	 * wrap shortcode with some wrappers
	 */
	public static function wrapShortcode($shortcode){
		$shortcode = "{".$shortcode."}";
		
		return($shortcode);
	}
	
	
	/**
	 * get image url from image id
	 */
	public static function getImageUrlFromImageID($imageID){
		
		return(null);
	}
	
	
	/**
	 * get image id from url
	 */
	public static function getImageIDFromUrl($urlImage){
		
		return(null);
	}
	
	
	/**
	 * get image url from image id
	 */
	public static function getThumbUrlFromImageID($imageID, $size = null){	
		
		return(null);
	}

	
	/**
	 * put addons view additional html
	 */
	public static function putAddonViewAddHtml(){
		
		$urlLayouts = HelperUC::getViewUrl_LayoutsList();
		$urlLibrary = HelperUC::getViewUrl(GlobalsUC::VIEW_LIBRARY);
		
		
		?>
		<div class="uc-buttons-panel unite-clearfix">
			<a href="<?php echo $urlLayouts?>" class="unite-float-left mright_20 unite-button-secondary"><?php HelperUC::putText("my_layouts")?></a>
			<a href="<?php echo $urlLibrary?>" class="unite-float-right mleft_20 unite-button-secondary"><?php _e("My Library", BLOXBUILDER_TEXTDOMAIN)?></a>
			
		</div>
		
	
	<?php
	}
	
	
	/**
	* get plugin paths array
	*/
	public static function getArrPluginsPaths(){
	
		$objPluginsBase = new AddonLibraryJoomlaPluginsBase();
		$arrPluginsPaths = $objPluginsBase->getPluginsPaths();
	
		return($arrPluginsPaths);
	}
	
	
	/**
	 * filter variable
	 */
	public static function sanitizeVar($var, $type){
	
		switch($type){
			case UniteFunctionsUC::SANITIZE_ID:
				if(empty($var))
					return("");
	
				$var = (int)$var;
				$var = abs($var);
	
				if($var == 0)
					return("");
			
			break;
			case UniteFunctionsUC::SANITIZE_KEY:
				$var = HelperProviderUC::sanitizeKey($var);
			break;
			case UniteFunctionsUC::SANITIZE_TEXT_FIELD:
				$var = HelperProviderUC::sanitizeTextField($var);
			break;
			case UniteFunctionsUC::SANITIZE_NOTHING:
				break;
			default:
				self::throwError("Wrong sanitize type: " . $type);
			break;
		}
	
		return($var);
	}
	
	
	/**
	 * put helper editor to help init other editors that has put by ajax
	 */
	public static function putInitHelperHtmlEditor(){
		
		$params = array();
		$params["mode"] = 1;
		
		?>
		<div style="display:none">
		<form id="uc_editor_helper_form" name="uc_editor_helper_form">
		<?php
		
		$editor = JEditor::getInstance("tinymce");
		
		//dmp($editor);exit();
		
		echo $editor->display("uc_editor_helper","","100%",200,5,5,true,null,null,null,$params);
		
		?>
		</form>
		
		<div class="canva_replace" style="display:none"></div>
			
		</div>
		
	<?php
	
	}
	
	/**
	 * set page title
	 */
	public static function setAdminPageTitle($title){
		
		if(self::$isStandAlone == false)
			return(false);
		
		GlobalsStandAlone::$adminTitle = $title;
				
	}
	
	/**
	 * get post title by id
	 */
	public static function getPostTitleByID($postID, $specialChars = false){
		
		$post = new UniteJoomlaArticleUC();
		$post->initByID($postID);
		$title = $post->getTitle($specialChars);
		
		return($title);
	}
	
	/**
	 * send email, throw error on fail
	 */
	public static function sendEmail($emailTo, $subject, $message){
        
		$mailer = JFactory::getMailer();
		
		if(UniteProviderFunctionsUC::$isStandAlone == true){
			
			$sendFrom = HelperUC::getGeneralSetting("form_admin_mail_from");
			$sendFromName = HelperUC::getGeneralSetting("form_admin_mail_from_name");
			
			UniteFunctionsUC::validateNotEmpty($sendFrom,__("Send from email",BLOXBUILDER_TEXTDOMAIN));
			UniteFunctionsUC::validateNotEmpty($sendFromName,__("Send from email",BLOXBUILDER_TEXTDOMAIN) );
			
		    $sendOutput = $mailer->sendMail($sendFrom, $sendFromName, $emailTo, $subject, $message);
		
		}else{
			
	        $mailer->isHtml(true);
	        $mailer->AddAddress($emailTo);
	        
	        $mailer->setSubject($subject);
	        $mailer->setBody($message);
	        
	        $sendOutput = $mailer->Send();
	        
		}
        
        if ($sendOutput !== true) {
        	
            if(getType($sendOutput) == "boolean" || empty($sendOutput)){
            	
					if(UniteProviderFunctionsUC::$isStandAlone == true)
            			UniteFunctionsUC::throwError("the email could not send. Please check that your server can send emails");
            		else
            			UniteFunctionsUC::throwError("the email could not send. Please check that joomla can send emails or admin email address");
            		
			}else{
							
				 	$errorMessage = $sendOutput->__toString();
					UniteFunctionsUC::throwError($message);
			}
			
        }

        
	}
	
	
	/**
	 * get menu items
	 */
	public static function getMenuItems($menuType, $showSubmenu = true){
		
		$arrItems = UniteFunctionJoomlaUC::getMenuItems($menuType, $showSubmenu);
		
		return($arrItems);
	}
	
	
	/**
	 * update plugin
	 */
	public static function updatePlugin(){
	    
	    $linkBack = HelperUC::getViewUrl_Default();
	    $htmlLinkBack = HelperHtmlUC::getHtmlLink($linkBack, "Go Back");
	    
	    
	    try{
	        
	    //check if zip exists
	    $zip = new UniteZipUC();
	    
	    dmp("Update in progress...");
	    
	    $arrFiles = UniteFunctionsUC::getVal($_FILES, "update_file");
	    
	    if(empty($arrFiles))
	        UniteFunctionsUC::throwError("Update file don't found.");
	        
	        $error = UniteFunctionsUC::getVal($arrFiles, "error");
	        if(!empty($error)){
	            $message = self::uploadFileCodeToMessage($error);
	            UniteFunctionsUC::throwError($message);
	        }
	        
	        $filename = UniteFunctionsUC::getVal($arrFiles, "name");
	        
	        if(empty($filename))
	            UniteFunctionsUC::throwError("Update filename not found.");

	            $fileType = UniteFunctionsUC::getVal($arrFiles, "type");
	            
	            $fileType = strtolower($fileType);
	            
	            $arrMimeTypes = array();
	            $arrMimeTypes[] = "application/zip";
	            $arrMimeTypes[] = "application/x-zip";
	            $arrMimeTypes[] = "application/x-zip-compressed";
	            $arrMimeTypes[] = "application/octet-stream";
	            $arrMimeTypes[] = "application/x-compress";
	            $arrMimeTypes[] = "application/x-compressed";
	            $arrMimeTypes[] = "multipart/x-zip";
	            
	            if(in_array($fileType, $arrMimeTypes) == false)
	                UniteFunctionsUC::throwError("The file uploaded is not zip.");

	                $filepathTemp = UniteFunctionsUC::getVal($arrFiles, "tmp_name");
	                if(file_exists($filepathTemp) == false)
	                    UniteFunctionsUC::throwError("Can't find the uploaded file.");
	                    
	                
	             //crate temp folder
	             $pathTemp = GlobalsUC::$path_cache;
	              UniteFunctionsUC::checkCreateDir($pathTemp);
	                
	              //create the update folder
	              $pathUpdate = $pathTemp."update_extract/";
	              UniteFunctionsUC::checkCreateDir($pathUpdate);
	              
	              if(!is_dir($pathUpdate))
	                  UniteFunctionsUC::throwError("Could not create temp extract path");
	                  
	               //remove all files in the update folder
	               $arrNotDeleted = UniteFunctionsUC::deleteDir($pathUpdate, false);
	            
	               if(!empty($arrNotDeleted)){
	                   $strNotDeleted = print_r($arrNotDeleted,true);
	                   UniteFunctionsUC::throwError("Could not delete those files from the update folder: $strNotDeleted");
	               }
	               
	               $pathUpdateFiles = $pathUpdate."files/";
	               UniteFunctionsUC::checkCreateDir($pathUpdateFiles);
	               if(!is_dir($pathUpdateFiles))
	                   UniteFunctionsUC::throwError("Could not create temp extract files path");
	                   
	               
	               //copy the zip file.
	               $filepathZip = $pathUpdate.$filename;
	               
	               $success = move_uploaded_file($filepathTemp, $filepathZip);
	               if($success == false)
	                   UniteFunctionsUC::throwError("Can't move the uploaded file here: ".$filepathZip.".");
	               
	               $zip->extract($filepathZip, $pathUpdateFiles);
	               
	               //check some file in folder to validate it's the real one:
	               $checkFilepath = $pathUpdateFiles."ajax.php";
	               
	               if(file_exists($checkFilepath) == false)
	                   UniteFunctionsUC::throwError("Wrong update extracted folder. The file: ".$checkFilepath." not found.");
	                   
	                $pathOriginalPlugin = GlobalsStandAlone::$pathBase;
	                 
	                $arrBlackList = array("config.php");
	                UniteFunctionsUC::copyDir($pathUpdateFiles, $pathOriginalPlugin,"",$arrBlackList);
	                
	                //delete the update
	                UniteFunctionsUC::deleteDir($pathUpdate);
	                
	                dmp("Updated Successfully, redirecting...");
	                echo "<script>location.href='$linkBack'</script>";
	                
	    }catch(Exception $e){
	        
	        //remove all files in the update folder
	        if(isset($pathUpdate) && !empty($pathUpdate))
	            UniteFunctionsUC::deleteDir($pathUpdate);
	            
	            $message = $e->getMessage();
	            $message .= " <br> Please update manually via the ftp, just overwrite all the files from the install zip you have";
	            echo "<div style='color:#B80A0A;font-size:18px;'><b>Update Error: </b> $message</div><br>";
	            echo $htmlLinkBack;
	            exit();
	    }
	    
	         
	            dmp($filename);
	             
	            exit();

	}
		
	
	public static function ______________OPTIONS______________(){}
	
	
	/**
	 * get options object
	 */
	public static function getOptionsObj(){
		if(empty(self::$objOptions))
			self::$objOptions = new ProviderOptionsUC();
		
		return(self::$objOptions);
	}
	
	
	/**
	 * add option
	 */
	public static function addOption($option, $value=""){
	
		$objOptions = self::getOptionsObj();
		$objOptions->addOption($option, $value="");
	
	}
	
	
	/**
	 * get option
	 */
	public static function getOption($option, $default = false){
		$objOptions = self::getOptionsObj();
	
		return $objOptions->getOption($option, $default);
	
	}
	
	/**
	 * update option
	 */
	public static function updateOption($option, $value){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->updateOption($option, $value);
	
		return($response);
	}
	
	/**
	 * emulate special wp option
	 */
	public static function updateOptionSpecial($option, $value, $isMultisite=false, $loadAtStartup=false){
	
		return self::updateOption($option, $value);
	}
	
	
	/**
	 * delete one option
	 * @param $option
	 */
	public static function deleteOption($option){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->deleteOption($option);
	
		return($response);
	}
	
	
	/**
	 * set transient
	 */
	public static function setTransient($transient, $value, $expiration = 0){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->setTransient($transient, $value, $expiration);
	
		return($response);
	}
	
	
	/**
	 * get transient
	 * if empty - get false
	 */
	public static function getTransient($transient){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->getTransient($transient);
	
		return($response);
	}
	
		
	public static function ______________ACTIONS_AND_FILTERS______________(){}
	
	
	/**
	 * add action
	 */
	public static function addAction($tag, $function_to_add){
		HelperProviderUC::add_filter($tag, $function_to_add);
	}

	/**
	 * add filter
	 */
	public static function addFilter($tag, $function_to_add, $priority = 10, $accepted_args = 1){
		HelperProviderUC::add_filter($tag, $function_to_add, $priority, $accepted_args);
	}
	
	
	/**
	 * apply filters
	 */
	public static function applyFilters($tag, $value){
		
		return call_user_func_array(array("HelperProviderUC","apply_filters"), func_get_args());
	}
	
	
	/**
	 * do action emulation. do nothing for now
	 */
	public static function doAction($tag){
	
		call_user_func_array(array("HelperProviderUC","do_action"), func_get_args());
	}
	
	/**
	 * convert url to new window
	 */
	public static function convertUrlToBlankWindow($url){
		$params = "ucwindow=blank";
		
		$url = UniteFunctionsUC::addUrlParams($url, $params);
		
		return($url);
	}
	
}
?>