<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');

class UniteCreatorLayoutOutput extends UniteCreatorLayoutOutputWork{

	
	/**
	 * get preview layout html
	 */
	public function getFullPreviewHtml(){
		
		$this->validateInited();
		
		
		$outputs = "";
		$title = $this->layout->getTitle();		
		$title = htmlspecialchars($title);
				
		//add layout preview html
		$this->addCssStylePreview();
				
		//get libraries, but not process provider
		
		$this->cssToBody = false;
		$this->isScriptsHardCoded = false;
		
		$htmlBody = $this->getHtml();
		
		$cssStyles = UniteProviderFunctionsUC::getCustomStyles();
				
		$arrScripts = UniteProviderFunctionsUC::getCustomScripts();

		$arrCustomTags = UniteProviderFunctionsUC::getCustomTags();
				
		$htmlJSScripts = HelperHtmlUC::getHtmlCustomScripts($arrScripts);
		
		$htmlCustomTags = HelperHtmlUC::getHtmlCustomTags($arrCustomTags);
				
		
		$arrIncludes = UniteProviderFunctionsUC::getArrScriptsAndStyleIncludes(true);
		$arrIncludesCss = $arrIncludes["styles"];
		$arrIncludesJs = $arrIncludes["scripts"];
		$arrIncludesLinks = $arrIncludes["links"];
		
		$document = JFactory::getDocument();
		
		$htmlIncludesLinks = HelperHtmlUC::getHtmlLinksIncludes($arrIncludesLinks, self::TAB2);
		$htmlIncludesCss = HelperHtmlUC::getHtmlCssIncludes($arrIncludesCss, self::TAB2);
		$htmlIncludesJs = HelperHtmlUC::getHtmlJsIncludes($arrIncludesJs, self::TAB2);
        
		$arrLayoutGlobalSettings = UniteCreatorLayout::getLayoutGlobalSettingsValues();
		
		$htmlHeadAddition = UniteFunctionsUC::getVal($arrLayoutGlobalSettings, "html_head");
		$htmlBodyAddition = UniteFunctionsUC::getVal($arrLayoutGlobalSettings, "html_body");
		
		$htmlHeadAddition = trim($htmlHeadAddition);
		$htmlBodyAddition = trim($htmlBodyAddition);
		
				
		$html = "";
		
		$htmlHead = "<!DOCTYPE html>".self::BR;
		$htmlHead .= "<html>".self::BR;
		$htmlHead .= self::TAB."<head>".self::BR;
		
		$html .= $htmlHead;
		$htmlHead = "";
		
		//get head html
		$htmlHead .= self::TAB2."<title>{$title}</title>".self::BR2;
		
		$htmlHead .= self::TAB2."<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">".self::BR2;
		
		if(!empty($htmlCustomTags))
			$htmlHead .= $htmlCustomTags.self::BR;
		
		if(!empty($htmlIncludesLinks))
			$htmlHead .= $htmlIncludesLinks.self::BR;
		
		if(!empty($htmlIncludesCss))
			$htmlHead .= $htmlIncludesCss.self::BR;
		
		if(!empty($cssStyles))
			$htmlHead .= "\n"."<style type='text/css'>\n".$cssStyles."\n</style>".self::BR;
		
		if(!empty($htmlHeadAddition))
		    $htmlHead .= "\n".$htmlHeadAddition.self::BR2;
			
		$html .= $htmlHead;
		$output["head"] = $htmlHead;
		
		$htmlAfterHead = "";
		$htmlAfterHead .= self::TAB."</head>".self::BR;
		
		//output body
		$htmlAfterHead .= self::TAB."<body>".self::BR;
		$htmlAfterHead .= self::BR.self::TAB2."<div class='uc-page-preview-wrapper'>";
		$htmlAfterHead .= self::BR.$htmlBody;
		$htmlAfterHead .= self::BR.self::TAB2."</div>".self::BR2;
		
		$html .= $htmlAfterHead;
		$output["after_head"] = $htmlAfterHead;
		
		$htmlEnd = "";
		$htmlEnd .= $htmlIncludesJs.self::BR;
		
		$htmlEnd .= $htmlJSScripts.self::BR;
		
		$htmlEnd .= $this->getFullPreviewHtml_getPluginsOutput();
		
		if(!empty($htmlBodyAddition))
		    $htmlEnd .= $htmlBodyAddition.self::BR;
		
		$htmlEnd .= self::BR.self::TAB."</body>".self::BR;
		$htmlEnd .= "</html>";
		
		$html .= $htmlEnd;
		$output["end"] = $htmlEnd;
		
		$output["full_html"] = $html;
		
		return($output);
	}
	
		
}

