<?php

/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');

class UniteCreatorWebAPI extends UniteCreatorWebAPIWork{

	/**
	 * filter catalog addons for another platforms items, such wp and joomla
	 */
	protected function filterCatalogAddonsStandAlone($arrCatalogAddons){

		if(UniteProviderFunctionsUC::$isStandAlone == false)
			return($arrCatalogAddons);
		
		if(empty($arrCatalogAddons))
			return($arrCatalogAddons);
				
		
		$arrCatalogAddonsNew = array();
		foreach($arrCatalogAddons as $catName => $arrAddons){
			
			$arrAddonsNew = array();
			
			$catNameLower = strtolower($catName);
			
			if(strpos($catNameLower, "article ") !== false)
				continue;
			
			if(strpos($catNameLower, "post ") !== false)
				continue;
			
			
			foreach($arrAddons as $addon){
				
				$title = UniteFunctionsUC::getVal($addon, "title");
				$name = UniteFunctionsUC::getVal($addon, "name");
				
				$titleLow = strtolower($title);
				
				if(strpos($name, "wordpress") !== false)
					continue;
				
				if(strpos($name, "joomla") !== false)
					continue;
				
				if(strpos($titleLow, "wordpress") !== false)
					continue;
				
				if(strpos($titleLow, "joomla") !== false)
					continue;
				
				if(strpos($name, "joomla") !== false)
					continue;
				
				if(strpos($name, "k2_basic") !== false)
					continue;
				
				if($name == "article")
					continue;
				
				if(strpos($name, "article ") !== false)
					continue;
				
				if(strpos($name, "post ") !== false)
					continue;

				
				$arrAddonsNew[] = $addon;
			}
			
			$arrCatalogAddonsNew[$catName] = $arrAddonsNew;
		}

		
		return($arrCatalogAddonsNew);
	}
	
	
	/**
	 * get catalog array by addons type
	 */
	public function getCatalogArray($objAddonsType){
		
		$arrCatalogItems = parent::getCatalogArray($objAddonsType);
		
		if($objAddonsType->isLayout == true)
			return($arrCatalogItems);

		if(UniteProviderFunctionsUC::$isStandAlone == true)
			$arrCatalogItems = $this->filterCatalogAddonsStandAlone($arrCatalogItems);
		
		return($arrCatalogItems);
	}
	
	
	/**
	 * get catalog array
	 */
	protected function getCatalogArray_addons(){
		
		$arrCatalogAddons = parent::getCatalogArray_addons();
		
		if(UniteProviderFunctionsUC::$isStandAlone == true)
			$arrCatalogItems = $this->filterCatalogAddonsStandAlone($arrCatalogAddons);
		
		return($arrCatalogAddons);		
	}
	
	
}