<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');


class UniteCreatorLayoutPreviewProvider extends UniteCreatorLayoutPreview{

	
	/**
	 * add preview button
	 */
	private function addToolbar_preview_new(){
		
		$urlLayoutsPreview = HelperUC::getViewUrl_LayoutPreview($this->layoutID);
		$urlLayoutsPreviewNew = $urlLayoutsPreview."&tmpl=component";
	
		$textPreview = __("Preview New Window",BLOXBUILDER_TEXTDOMAIN);
	
		$html = "";
		$html .= "<a href=\"{$urlLayoutsPreviewNew}\" target=\"_blank\" class=\"unite-button-secondary\">{$textPreview}</a>";
		$html .= "<span class='uc-toolbar-sap'></span>";
	
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "preview_button");
	
	}
	
	
	/**
	 * add grid settings button
	 */
	private function addToolbar_toList(){
	
		$textBack = HelperUC::getText("back_to_layouts_list");
		
		$urlLayoutsList = HelperUC::getViewUrl_LayoutsList();
		
		$html = "";
		$html .= "<a href=\"{$urlLayoutsList}\" class=\"unite-button-secondary\">{$textBack}</a>";
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "url_back");
	
	}

	
	/**
	 * add grid settings button
	 */
	private function addToolbar_editLayout(){
		
		$textEdit = HelperUC::getText("edit_layout");
		$urlEdit = HelperUC::getViewUrl_Layout($this->layoutID);
		
		$html = "";
		$html .= "<a href=\"{$urlEdit}\" class=\"unite-button-secondary\">{$textEdit}</a>";
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "url_edit");
		
	}
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addToolbar_toList();
		$this->addToolbar_editLayout();
		$this->addToolbar_preview_new();
	}
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
		
		$title = $this->getHeaderTitle();
	
		HelperProviderUC::setToolbarTitle($title);
				
	}
	
			
	
	/**
	 * constructor
	 */
	public function __construct(){
		
		$this->showToolbar = false;
				
		parent::__construct();
		
		$isAdmin = UniteProviderFunctionsUC::isAdmin();
		
		if($isAdmin == true){
			$this->setJoomlaHeaderText();
			$this->addToolbar();
			UniteFunctionJoomlaUC::addHtmlToHead('<meta name="viewport" content="width=device-width, initial-scale=1">');
		}
		
		//add tag to head
		if($isAdmin == true)
			$this->display();
		else
			$this->outputLayout(true);
	}
	
}